<script setup lang="ts">
import { FormRules, ElForm } from "element-plus";
import { reactive, ref } from "vue";
import { httpUpdate, httpAdd, httpDetail } from "/@/api/parameter/company";
import { responseHandle } from "/@/utils/responseHandle";
import { useNav } from "/@/layout/hooks/useNav";

enum FROM_TYPE {
  create = "create",
  edit = "edit",
  view = "view"
}
const { logout } = useNav();
const showModel = ref(false);
const TYPE = ref<FROM_TYPE>(FROM_TYPE.create);
const formRef = ref<InstanceType<typeof ElForm>>(null);
const loading = ref(false);
const titleType = ref("");
const id = ref("");
const emit = defineEmits(["reload"]);
const initform = {
  title: "",
  contacts: "",
  id: "",
  mobile: "",
  remark: ""
};
const ruleForm = ref({ ...initform });
const rules = reactive<FormRules>({
  title: [{ required: true, trigger: "bulr", message: "请输入企业" }],
  contacts: [{ required: true, trigger: "bulr", message: "请输入联系人" }],
  mobile: [{ required: true, trigger: "blur", message: "请输入联系方式" }],
  remark: [{ required: false, trigger: "blur", message: "请输入备注" }]
});
const initData = async () => {
  const { code, data, message } = await httpDetail({ id: id.value });
  responseHandle({
    code,
    message,
    logout,
    handler: () => {
      console.log(data);
      Object.keys(ruleForm.value).forEach(key => {
        ruleForm.value[key] = data[key] ? data[key] + "" : "";
      });
    }
  });
};
async function show(node: any, did: string, isCreate: string) {
  id.value = did;
  Object.keys(ruleForm.value).forEach(key => {
    ruleForm.value[key] = initform[key] ? initform[key] + "" : "";
  });
  TYPE.value = isCreate;
  switch (TYPE.value) {
    case "create":
      titleType.value = "新建企业";
      break;
    case "edit":
      titleType.value = "编辑企业";
      break;
    case "view":
      titleType.value = "企业详情";
      break;
    default:
      titleType.value = "新建企业";
  }
  if (TYPE.value !== "create") {
    await initData();
  }

  showModel.value = true;
}

function handleUpdate() {
  const data = {
    ...ruleForm.value
  };

  return {
    data,
    api: httpUpdate
  };
}

function handleCreate() {
  const data = {
    ...ruleForm.value
  };

  return {
    data,
    api: httpAdd
  };
}

function handleSave() {
  formRef.value.validate(async vaild => {
    if (vaild) {
      if (loading.value) return;
      const handler =
        TYPE.value === FROM_TYPE.create ? handleCreate : handleUpdate;

      loading.value = true;
      const { api, data } = handler();
      const { message, code } = await api(data);
      loading.value = false;
      responseHandle({
        code,
        message,
        logout,
        handler: () => {
          showModel.value = false;
          emit("reload");
        }
      });
    }
  });
}

defineExpose({
  show
});
</script>

<template>
  <el-dialog
    v-model="showModel"
    :close-on-press-escape="false"
    center
    append-to-body
    destroy-on-close
    :width="'900px'"
    :title="titleType"
    v-loading="loading"
  >
    <el-form
      ref="formRef"
      :model="ruleForm"
      :rules="rules"
      label-width="90px"
      style="margin-top: -10px"
      class="demo-ruleForm"
      status-icon
    >
      <el-row>
        <el-col :span="24">
          <el-form-item label="企业名称" prop="title">
            <ElInput
              placeholder="企业名称"
              :disabled="TYPE === 'view'"
              maxlength="50"
              v-model="ruleForm.title"
            /> </el-form-item
        ></el-col>
        <el-col :span="12">
          <el-form-item label="联系人" prop="contacts">
            <ElInput
              placeholder="联系人"
              :disabled="TYPE === 'view'"
              maxlength="50"
              v-model="ruleForm.contacts"
            /> </el-form-item
        ></el-col>
        <el-col :span="12">
          <el-form-item label="联系方式" prop="mobile">
            <ElInput
              placeholder="联系方式"
              :disabled="TYPE === 'view'"
              maxlength="50"
              v-model="ruleForm.mobile"
            /> </el-form-item
        ></el-col>
        <el-col :span="24">
          <el-form-item label="备注" prop="remark">
            <ElInput
              placeholder="备注"
              :disabled="TYPE === 'view'"
              maxlength="500"
              type="textarea"
              v-model="ruleForm.remark"
            /> </el-form-item
        ></el-col>
      </el-row>
      <div class="flex justify-end">
        <el-button
          v-if="TYPE !== 'view'"
          :loading="loading"
          :disabled="loading"
          type="primary"
          @click="handleSave"
          >保存</el-button
        >
        <el-button @click="showModel = false">取消</el-button>
      </div>
    </el-form>
  </el-dialog>
</template>
